%This M-Function was created automatically by PSG Toolbox.
%See section "Special Subroutines in Toolbox -> User Subroutine in Toolbox" in PSG Help Manual.
%
%Input variables:
%
%Inputs                                    PSG Type    PSG Object                           Location in Problem Statement                                    Class
%matrix_cs_project_selection_npv_data      data        matrix_cs_project_selection_npv      linear(matrix_cs_project_selection_npv)                          double
%matrix_cs_project_selection_npv_vars      vars        matrix_cs_project_selection_npv      linear(matrix_cs_project_selection_npv)                          cell
%matrix_cs_project_selection_costs_data    data        matrix_cs_project_selection_costs    fxchg_pos(parameter_alpha, matrix_cs_project_selection_costs)    double
%matrix_cs_project_selection_costs_vars    vars        matrix_cs_project_selection_costs    fxchg_pos(parameter_alpha, matrix_cs_project_selection_costs)    cell
%parameter_bound_data                      data        parameter_bound                      Constraint: <= parameter_bound, linearize = 1                    double
%parameter_alpha_data                      data        parameter_alpha                      fxchg_pos(parameter_alpha, matrix_cs_project_selection_costs)    double
%parameter_bound_1_data                    data        parameter_bound_1                    Box: >= parameter_bound_1, <= parameter_bound_2                  double
%parameter_bound_2_data                    data        parameter_bound_2                    Box: >= parameter_bound_1, <= parameter_bound_2                  double
%parameter_solver_data                     data        parameter_solver                     Solver: parameter_solver                                         char
%
%Output variables:
%
%solution_str = string with solution of problem;
%outargstruc_arr = array of output PSG data structures;


function [solution_str,outargstruc_arr] = Optimization_subroutine(matrix_cs_project_selection_npv_data,matrix_cs_project_selection_npv_vars,matrix_cs_project_selection_costs_data,matrix_cs_project_selection_costs_vars,parameter_bound_data,parameter_alpha_data,parameter_bound_1_data,parameter_bound_2_data,parameter_solver_data)

%Pack data to PSG structure:
count = 0;
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_cs_project_selection_npv',matrix_cs_project_selection_npv_data,matrix_cs_project_selection_npv_vars,[],[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_cs_project_selection_costs',matrix_cs_project_selection_costs_data,matrix_cs_project_selection_costs_vars,[],[]);
%Define problem statement:
problem_statement = sprintf('%s\n',...
'maximize',...
'  linear(matrix_cs_project_selection_npv)',...
'Constraint: <= parameter_bound, linearize = 1',...
'  fxchg_pos(parameter_alpha, matrix_cs_project_selection_costs)',...
'Box: >= parameter_bound_1, <= parameter_bound_2',...
'Solver: parameter_solver',...
' ');
%Change parameters with their values in problem statement:
problem_statement = strrep(problem_statement,'parameter_bound_1',num2str(parameter_bound_1_data));
problem_statement = strrep(problem_statement,'parameter_bound_2',num2str(parameter_bound_2_data));
problem_statement = strrep(problem_statement,'parameter_solver',parameter_solver_data);
problem_statement = strrep(problem_statement,'parameter_bound',num2str(parameter_bound_data));
problem_statement = strrep(problem_statement,'parameter_alpha',num2str(parameter_alpha_data));

%Optimize problem using mpsg_solver function:
[solution_str, outargstruc_arr] = mpsg_solver(problem_statement, iargstruc_arr);
results = psg_convert_outargstruc(solution_str,outargstruc_arr);
outargstruc_arr = results.data;
solution_str = results.string;

%=======================================================================|
%American Optimal Decisions, Inc. Copyright                             |
%Copyright American Optimal Decisions, Inc. 2007-2016.                 |
%American Optimal Decisions (AOD) retains copyrights to this material.  |
%                                                                       |
%Permission to reproduce this document and to prepare derivative works  |
%from this document for internal use is granted, provided the copyright |
%and No Warranty  statements are included with all reproductions       |
%and derivative works.                                                  |
%                                                                       |
%For information regarding external or commercial use of copyrighted    |
%materials owned by AOD, contact AOD at support@aorda.com.              |
%=======================================================================|
 

